**1. zadatak**

Zastavica je skrivena u memoriji elektroničke kontrolne jedinice s 32 bitnim procesorom. Komunikacija s elektroničkom kontrolnom jedinicom moguća je putem virtualnog mrežnog sučelja CAN "dcan0".
- potrebni alati: Scapy, caringcaribou

Za pokretanje zadatka potrebni su moduli jezgre:
 - can_gw
 - can
 - iso_tp

```
modprobe can_gw
modprobe can
modprobe can_isotp
```

Provjeriti s ```lsmod | grep can```.

Zadatak i network driver plugin dostupni su na dockerhubu pa se postavljanje vrši kroz docker naredbe:

```
docker plugin install lovrogm/dockercan:latest
docker pull lovrogm/uds_ctf_task1:latest

docker network create -o centralised=false -o canfd=false -o host_if=dcan0 --driver lovrogm/dockercan:latest can
docker run --network can lovrogm/uds_ctf_task1:latest
```

Za korištenje caringcariboua potrebno je dodati ~/.canrc konfiguraciju (datoteka se dodaje u /home/user):

```
[default]
interface = socketcan
channel = dcan0
```

<details>
<summary>Rješenje</summary>

- Natjecatelj koristi caringcaribou alat odnosno njegov uds discovery modul za pronalazak ISO-TP adrese na kojoj sluša UDS poslužitelj
- Potom korištenjem naredbe caringcaribou uds services skenira dostupne servise, među kojima se nalazi ReadMemoryByAddress servis
- Iz teksta zadatka potrebno je zaključiti da je u formatu ReadMemoryByAddress poruke potrebno specificirati 32 bitnu adresu (memoryAddressLen=4). Uz to potrebno je i pogoditi memorySizeLen parametar koji predstavlja duljinu polja za veličinu podataka koje želimo isčitati u oktetima.
 - parametar memorySizeLen može biti u rasponu [1, 4], za pogrešan parametar poslužitelj vraća invalidFormat grešku.
- Potrebno je napisati Scapy skriptu ili skriptu koja koristi can-utils alate isotprecv, isotpsend kako bi se isčitao cijeli sadržaj memorije ECU-a (solution.py)
- Pokretanjem naredbe strings na dobivenoj binarnoj datoteci natjecatelj pronalazi zastavicu.

</details>
